// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 1 "parse/thrifty.yy"

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/**
 * Thrift parser.
 *
 * This parser is used on a thrift definition file.
 *
 */

#define __STDC_LIMIT_MACROS
#define __STDC_FORMAT_MACROS

#include <cassert>
#include <stdio.h>
#include <inttypes.h>
#include <limits.h>
#include <stack>
#include <utility>

#include <boost/optional.hpp>

#include <thrift/compiler/ast/t_scope.h>
#include <thrift/compiler/ast/t_union.h>
#include <thrift/compiler/parse/parsing_driver.h>
#include <thrift/compiler/ast/t_container.h>

/**
 * Note macro expansion because this is different between OSS and internal
 * build, sigh.
 */
#include THRIFTY_HH

/**
 * Declare fbthrift_compiler_parse_lex() so we can use it.
 */
YY_DECL;
#define yylex fbthrift_compiler_parse_lex

namespace apache {
namespace thrift {
namespace compiler {
namespace {

int g_arglist = 0;

// Assume ownership of a pointer.
template <typename T>
std::unique_ptr<T> own(T* ptr) {
  return std::unique_ptr<T>(ptr);
}

} // namespace
} // namespace compiler
} // namespace thrift
} // namespace apache


#line 117 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"


#include "thrifty.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 97 "parse/thrifty.yy"
namespace apache { namespace thrift { namespace compiler { namespace yy {
#line 215 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"

  /// Build a parser object.
  parser::parser (apache::thrift::compiler::parsing_driver& driver_yyarg, apache::thrift::compiler::yyscan_t raw_scanner_yyarg, YYSTYPE * yylval_param_yyarg, YYLTYPE * yylloc_param_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      raw_scanner (raw_scanner_yyarg),
      yylval_param (yylval_param_yyarg),
      yylloc_param (yylloc_param_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.YY_MOVE_OR_COPY< boost::optional<t_field_id> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        value.YY_MOVE_OR_COPY< t_annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.YY_MOVE_OR_COPY< t_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.YY_MOVE_OR_COPY< t_const* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.YY_MOVE_OR_COPY< t_const_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.YY_MOVE_OR_COPY< t_container* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        value.YY_MOVE_OR_COPY< t_def_attrs* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.YY_MOVE_OR_COPY< t_doc > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Enum: // Enum
        value.YY_MOVE_OR_COPY< t_enum* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumValueDef: // EnumValueDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.YY_MOVE_OR_COPY< t_enum_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        value.YY_MOVE_OR_COPY< t_enum_value_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.YY_MOVE_OR_COPY< t_error_blame > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.YY_MOVE_OR_COPY< t_error_kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.YY_MOVE_OR_COPY< t_error_safety > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Exception: // Exception
        value.YY_MOVE_OR_COPY< t_exception* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.YY_MOVE_OR_COPY< t_field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.YY_MOVE_OR_COPY< t_field_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        value.YY_MOVE_OR_COPY< t_field_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Function: // Function
        value.YY_MOVE_OR_COPY< t_function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.YY_MOVE_OR_COPY< t_function_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.YY_MOVE_OR_COPY< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.YY_MOVE_OR_COPY< t_interaction* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        value.YY_MOVE_OR_COPY< t_paramlist* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.YY_MOVE_OR_COPY< t_ref<t_base_type> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Definition: // Definition
        value.YY_MOVE_OR_COPY< t_ref<t_node> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Extends: // Extends
        value.YY_MOVE_OR_COPY< t_ref<t_service> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Service: // Service
        value.YY_MOVE_OR_COPY< t_service* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.YY_MOVE_OR_COPY< t_sink* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.YY_MOVE_OR_COPY< t_stream_response* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Struct: // Struct
        value.YY_MOVE_OR_COPY< t_struct* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.YY_MOVE_OR_COPY< t_struct_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.YY_MOVE_OR_COPY< t_throws* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        value.YY_MOVE_OR_COPY< t_type_ref > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.YY_MOVE_OR_COPY< t_typedef* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.YY_MOVE_OR_COPY< t_typethrowspair > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Union: // Union
        value.YY_MOVE_OR_COPY< t_union* > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.move< boost::optional<t_field_id> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        value.move< t_annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.move< t_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.move< t_const* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.move< t_const_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.move< t_container* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        value.move< t_def_attrs* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.move< t_doc > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Enum: // Enum
        value.move< t_enum* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumValueDef: // EnumValueDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.move< t_enum_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        value.move< t_enum_value_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.move< t_error_blame > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.move< t_error_kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.move< t_error_safety > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Exception: // Exception
        value.move< t_exception* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.move< t_field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.move< t_field_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        value.move< t_field_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Function: // Function
        value.move< t_function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.move< t_function_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.move< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.move< t_interaction* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        value.move< t_paramlist* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.move< t_ref<t_base_type> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Definition: // Definition
        value.move< t_ref<t_node> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Extends: // Extends
        value.move< t_ref<t_service> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Service: // Service
        value.move< t_service* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.move< t_sink* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.move< t_stream_response* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Struct: // Struct
        value.move< t_struct* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.move< t_throws* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        value.move< t_type_ref > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.move< t_typedef* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.move< t_typethrowspair > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Union: // Union
        value.move< t_union* > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.copy< boost::optional<t_field_id> > (that.value);
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        value.copy< t_annotation* > (that.value);
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.copy< t_annotations* > (that.value);
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.copy< t_const* > (that.value);
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.copy< t_const_value* > (that.value);
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.copy< t_container* > (that.value);
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        value.copy< t_def_attrs* > (that.value);
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.copy< t_doc > (that.value);
        break;

      case symbol_kind::S_Enum: // Enum
        value.copy< t_enum* > (that.value);
        break;

      case symbol_kind::S_EnumValueDef: // EnumValueDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.copy< t_enum_value* > (that.value);
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        value.copy< t_enum_value_list* > (that.value);
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.copy< t_error_blame > (that.value);
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.copy< t_error_kind > (that.value);
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.copy< t_error_safety > (that.value);
        break;

      case symbol_kind::S_Exception: // Exception
        value.copy< t_exception* > (that.value);
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.copy< t_field* > (that.value);
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.copy< t_field_list* > (that.value);
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        value.copy< t_field_qualifier > (that.value);
        break;

      case symbol_kind::S_Function: // Function
        value.copy< t_function* > (that.value);
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.copy< t_function_list* > (that.value);
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.copy< t_function_qualifier > (that.value);
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.copy< t_interaction* > (that.value);
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        value.copy< t_paramlist* > (that.value);
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.copy< t_ref<t_base_type> > (that.value);
        break;

      case symbol_kind::S_Definition: // Definition
        value.copy< t_ref<t_node> > (that.value);
        break;

      case symbol_kind::S_Extends: // Extends
        value.copy< t_ref<t_service> > (that.value);
        break;

      case symbol_kind::S_Service: // Service
        value.copy< t_service* > (that.value);
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.copy< t_sink* > (that.value);
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.copy< t_stream_response* > (that.value);
        break;

      case symbol_kind::S_Struct: // Struct
        value.copy< t_struct* > (that.value);
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.copy< t_struct_annotations* > (that.value);
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.copy< t_throws* > (that.value);
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        value.copy< t_type_ref > (that.value);
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.copy< t_typedef* > (that.value);
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.copy< t_typethrowspair > (that.value);
        break;

      case symbol_kind::S_Union: // Union
        value.copy< t_union* > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.move< boost::optional<t_field_id> > (that.value);
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.move< double > (that.value);
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        value.move< t_annotation* > (that.value);
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.move< t_annotations* > (that.value);
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.move< t_const* > (that.value);
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.move< t_const_value* > (that.value);
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.move< t_container* > (that.value);
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        value.move< t_def_attrs* > (that.value);
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.move< t_doc > (that.value);
        break;

      case symbol_kind::S_Enum: // Enum
        value.move< t_enum* > (that.value);
        break;

      case symbol_kind::S_EnumValueDef: // EnumValueDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.move< t_enum_value* > (that.value);
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        value.move< t_enum_value_list* > (that.value);
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.move< t_error_blame > (that.value);
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.move< t_error_kind > (that.value);
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.move< t_error_safety > (that.value);
        break;

      case symbol_kind::S_Exception: // Exception
        value.move< t_exception* > (that.value);
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.move< t_field* > (that.value);
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.move< t_field_list* > (that.value);
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        value.move< t_field_qualifier > (that.value);
        break;

      case symbol_kind::S_Function: // Function
        value.move< t_function* > (that.value);
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.move< t_function_list* > (that.value);
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.move< t_function_qualifier > (that.value);
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.move< t_interaction* > (that.value);
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        value.move< t_paramlist* > (that.value);
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.move< t_ref<t_base_type> > (that.value);
        break;

      case symbol_kind::S_Definition: // Definition
        value.move< t_ref<t_node> > (that.value);
        break;

      case symbol_kind::S_Extends: // Extends
        value.move< t_ref<t_service> > (that.value);
        break;

      case symbol_kind::S_Service: // Service
        value.move< t_service* > (that.value);
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.move< t_sink* > (that.value);
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.move< t_stream_response* > (that.value);
        break;

      case symbol_kind::S_Struct: // Struct
        value.move< t_struct* > (that.value);
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (that.value);
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.move< t_throws* > (that.value);
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        value.move< t_type_ref > (that.value);
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.move< t_typedef* > (that.value);
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.move< t_typethrowspair > (that.value);
        break;

      case symbol_kind::S_Union: // Union
        value.move< t_union* > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, raw_scanner, yylval_param, yylloc_param));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        yylhs.value.emplace< boost::optional<t_field_id> > ();
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        yylhs.value.emplace< t_annotation* > ();
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        yylhs.value.emplace< t_annotations* > ();
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        yylhs.value.emplace< t_const* > ();
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        yylhs.value.emplace< t_const_value* > ();
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        yylhs.value.emplace< t_container* > ();
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        yylhs.value.emplace< t_def_attrs* > ();
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        yylhs.value.emplace< t_doc > ();
        break;

      case symbol_kind::S_Enum: // Enum
        yylhs.value.emplace< t_enum* > ();
        break;

      case symbol_kind::S_EnumValueDef: // EnumValueDef
      case symbol_kind::S_EnumValue: // EnumValue
        yylhs.value.emplace< t_enum_value* > ();
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        yylhs.value.emplace< t_enum_value_list* > ();
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        yylhs.value.emplace< t_error_blame > ();
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        yylhs.value.emplace< t_error_kind > ();
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        yylhs.value.emplace< t_error_safety > ();
        break;

      case symbol_kind::S_Exception: // Exception
        yylhs.value.emplace< t_exception* > ();
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        yylhs.value.emplace< t_field* > ();
        break;

      case symbol_kind::S_FieldList: // FieldList
        yylhs.value.emplace< t_field_list* > ();
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        yylhs.value.emplace< t_field_qualifier > ();
        break;

      case symbol_kind::S_Function: // Function
        yylhs.value.emplace< t_function* > ();
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        yylhs.value.emplace< t_function_list* > ();
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        yylhs.value.emplace< t_function_qualifier > ();
        break;

      case symbol_kind::S_Interaction: // Interaction
        yylhs.value.emplace< t_interaction* > ();
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        yylhs.value.emplace< t_paramlist* > ();
        break;

      case symbol_kind::S_BaseType: // BaseType
        yylhs.value.emplace< t_ref<t_base_type> > ();
        break;

      case symbol_kind::S_Definition: // Definition
        yylhs.value.emplace< t_ref<t_node> > ();
        break;

      case symbol_kind::S_Extends: // Extends
        yylhs.value.emplace< t_ref<t_service> > ();
        break;

      case symbol_kind::S_Service: // Service
        yylhs.value.emplace< t_service* > ();
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        yylhs.value.emplace< t_sink* > ();
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        yylhs.value.emplace< t_stream_response* > ();
        break;

      case symbol_kind::S_Struct: // Struct
        yylhs.value.emplace< t_struct* > ();
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        yylhs.value.emplace< t_struct_annotations* > ();
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        yylhs.value.emplace< t_throws* > ();
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        yylhs.value.emplace< t_type_ref > ();
        break;

      case symbol_kind::S_Typedef: // Typedef
        yylhs.value.emplace< t_typedef* > ();
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        yylhs.value.emplace< t_typethrowspair > ();
        break;

      case symbol_kind::S_Union: // Union
        yylhs.value.emplace< t_union* > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // Program: HeaderList DefinitionList
#line 301 "parse/thrifty.yy"
    {
      driver.debug("Program -> Headers DefinitionList");
      /*
      TODO(dreiss): Decide whether full-program doctext is worth the trouble.
      if ($1) {
        driver.program->set_doc($1);
      }
      */
      driver.clear_doctext();
    }
#line 1551 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 3: // Identifier: tok_identifier
#line 314 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 1559 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 4: // Identifier: tok_sink
#line 319 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "sink";
    }
#line 1567 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 5: // Identifier: tok_oneway
#line 323 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "oneway";
    }
#line 1575 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 6: // Identifier: tok_readonly
#line 327 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "readonly";
    }
#line 1583 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 7: // Identifier: tok_idempotent
#line 331 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "idempotent";
    }
#line 1591 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 8: // Identifier: tok_safe
#line 335 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "safe";
    }
#line 1599 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 9: // Identifier: tok_transient
#line 339 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "transient";
    }
#line 1607 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 10: // Identifier: tok_stateful
#line 343 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "stateful";
    }
#line 1615 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 11: // Identifier: tok_permanent
#line 347 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "permanent";
    }
#line 1623 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 12: // Identifier: tok_server
#line 351 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "server";
    }
#line 1631 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 13: // Identifier: tok_client
#line 355 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "client";
    }
#line 1639 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 14: // CaptureDocText: %empty
#line 361 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_doc > () = driver.doctext;
        driver.doctext = boost::none;
      } else {
        yylhs.value.as < t_doc > () = boost::none;
      }
    }
#line 1652 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 15: // DestroyDocText: %empty
#line 372 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.clear_doctext();
      }
    }
#line 1662 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 16: // HeaderList: HeaderList DestroyDocText Header
#line 382 "parse/thrifty.yy"
    {
      driver.debug("HeaderList -> HeaderList Header");
    }
#line 1670 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 17: // HeaderList: %empty
#line 386 "parse/thrifty.yy"
    {
      driver.debug("HeaderList -> ");
    }
#line 1678 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 18: // Header: Include
#line 392 "parse/thrifty.yy"
    {
      driver.debug("Header -> Include");
    }
#line 1686 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 19: // Header: tok_namespace Identifier Identifier
#line 396 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier Identifier");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > ());
      }
    }
#line 1697 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 20: // Header: tok_namespace Identifier tok_literal
#line 403 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > ());
      }
    }
#line 1708 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 21: // Header: tok_cpp_include tok_literal
#line 410 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_cpp_include tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_cpp_include(yystack_[0].value.as < std::string > ());
      }
    }
#line 1719 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 22: // Header: tok_hs_include tok_literal
#line 417 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_hs_include tok_literal");
      // Do nothing. This syntax is handled by the hs compiler
    }
#line 1728 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 23: // Include: tok_include tok_literal
#line 424 "parse/thrifty.yy"
    {
      driver.debug("Include -> tok_include tok_literal");
      if (driver.mode == parsing_mode::INCLUDES) {
        std::string path = driver.include_file(std::string(yystack_[0].value.as < std::string > ()));
        if (!path.empty()) {
          if (driver.program_cache.find(path) == driver.program_cache.end()) {
            auto included_program = driver.program->add_include(path, std::string(yystack_[0].value.as < std::string > ()), driver.scanner->get_lineno());
            driver.program_cache[path] = included_program.get();
            driver.program_bundle->add_program(std::move(included_program));
          } else {
            auto include = std::make_unique<t_include>(driver.program_cache[path]);
            include->set_lineno(driver.scanner->get_lineno());
            driver.program->add_include(std::move(include));
          }
        }
      }
    }
#line 1750 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 24: // DefinitionAttrs: CaptureDocText StructuredAnnotations
#line 444 "parse/thrifty.yy"
    {
      driver.debug("DefinitionAttrs -> CaptureDocText StructuredAnnotations");
      if (yystack_[1].value.as < t_doc > () || yystack_[0].value.as < t_struct_annotations* > () != nullptr) {
        yylhs.value.as < t_def_attrs* > () = new t_def_attrs{std::move(yystack_[1].value.as < t_doc > ()), own(yystack_[0].value.as < t_struct_annotations* > ())};
        driver.avoid_last_token_loc(!yystack_[1].value.as < t_doc > (), yylhs.location, yystack_[0].location);
      } else {
        yylhs.value.as < t_def_attrs* > () = nullptr;
      }
    }
#line 1764 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 25: // DefinitionList: DefinitionList Definition
#line 456 "parse/thrifty.yy"
    {
      driver.debug("DefinitionList -> DefinitionList Definition");
    }
#line 1772 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 26: // DefinitionList: %empty
#line 460 "parse/thrifty.yy"
    {
      driver.debug("DefinitionList -> ");
    }
#line 1780 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 27: // Definition: Const
#line 466 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Const");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_const* > ()));
    }
#line 1789 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 28: // Definition: Typedef
#line 471 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Typedef");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_typedef* > ()));
    }
#line 1798 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 29: // Definition: Enum
#line 476 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Enum");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_enum* > ()));
    }
#line 1807 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 30: // Definition: Struct
#line 481 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Struct");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_struct* > ()));
    }
#line 1816 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 31: // Definition: Union
#line 486 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Union");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_union* > ()));
    }
#line 1825 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 32: // Definition: Exception
#line 491 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Exception");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_exception* > ()));
    }
#line 1834 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 33: // Definition: Service
#line 496 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Service");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_service* > ()));
    }
#line 1843 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 34: // Definition: Interaction
#line 501 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Interaction");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_interaction* > ()));
    }
#line 1852 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 35: // $@1: %empty
#line 508 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Typedef);
    }
#line 1860 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 36: // Typedef: DefinitionAttrs tok_typedef FieldType Identifier $@1 TypeAnnotations
#line 512 "parse/thrifty.yy"
    {
      driver.debug("TypeDef => DefinitionAttrs tok_typedef FieldType "
          "Identifier TypeAnnotations");
      yylhs.value.as < t_typedef* > () = new t_typedef(driver.program, std::move(yystack_[2].value.as < std::string > ()), std::move(yystack_[3].value.as < t_type_ref > ()));
      driver.avoid_last_token_loc(yystack_[5].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[4].location);
      driver.finish_node(
          yylhs.value.as < t_typedef* > (), LineType::Typedef, yylhs.location, own(yystack_[5].value.as < t_def_attrs* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 1873 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 37: // CommaOrSemicolon: ","
#line 523 "parse/thrifty.yy"
    {}
#line 1879 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 38: // CommaOrSemicolon: ";"
#line 525 "parse/thrifty.yy"
    {}
#line 1885 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 39: // CommaOrSemicolonOptional: CommaOrSemicolon
#line 529 "parse/thrifty.yy"
    {
      yylhs.value.as < bool > () = true;
    }
#line 1893 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 40: // CommaOrSemicolonOptional: %empty
#line 533 "parse/thrifty.yy"
    {
      yylhs.value.as < bool > () = false;
    }
#line 1901 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 41: // $@2: %empty
#line 539 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Enum);
    }
#line 1909 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 42: // Enum: DefinitionAttrs tok_enum Identifier $@2 "{" EnumValueList "}" TypeAnnotations
#line 543 "parse/thrifty.yy"
    {
      driver.debug("Enum => DefinitionAttrs tok_enum Identifier { EnumValueList } TypeAnnotations");
      yylhs.value.as < t_enum* > () = new t_enum(driver.program, std::move(yystack_[5].value.as < std::string > ()));
      auto values = own(yystack_[2].value.as < t_enum_value_list* > ());
      yylhs.value.as < t_enum* > ()->set_values(std::move(*values));
      driver.avoid_last_token_loc(yystack_[7].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[6].location);
      driver.finish_node(
          yylhs.value.as < t_enum* > (), LineType::Enum, yylhs.location, own(yystack_[7].value.as < t_def_attrs* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 1923 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 43: // EnumValueList: EnumValueList EnumValueDef
#line 555 "parse/thrifty.yy"
    {
      driver.debug("EnumValueList -> EnumValueList EnumValueDef");
      yylhs.value.as < t_enum_value_list* > () = yystack_[1].value.as < t_enum_value_list* > ();
      yylhs.value.as < t_enum_value_list* > ()->emplace_back(own(yystack_[0].value.as < t_enum_value* > ()));
    }
#line 1933 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 44: // EnumValueList: %empty
#line 561 "parse/thrifty.yy"
    {
      driver.debug("EnumValueList -> ");
      yylhs.value.as < t_enum_value_list* > () = new t_enum_value_list;
    }
#line 1942 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 45: // $@3: %empty
#line 568 "parse/thrifty.yy"
    {
      driver.start_node(LineType::EnumValue);
    }
#line 1950 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 46: // EnumValueDef: DefinitionAttrs EnumValue $@3 TypeAnnotations CommaOrSemicolonOptional
#line 572 "parse/thrifty.yy"
    {
      driver.debug("EnumValueDef => DefinitionAttrs EnumValue "
        "TypeAnnotations CommaOrSemicolonOptional");
      driver.avoid_last_token_loc(yystack_[4].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[3].location);
      driver.finish_node(
          yystack_[3].value.as < t_enum_value* > (), LineType::EnumValue, yylhs.location, own(yystack_[4].value.as < t_def_attrs* > ()), own(yystack_[1].value.as < t_annotations* > ()));
      yylhs.value.as < t_enum_value* > () = yystack_[3].value.as < t_enum_value* > ();
    }
#line 1963 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 47: // EnumValue: Identifier "=" tok_int_constant
#line 583 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier = tok_int_constant");
      if (yystack_[0].value.as < int64_t > () < INT32_MIN || yystack_[0].value.as < int64_t > () > INT32_MAX) {
        // Note: this used to be just a warning.  However, since thrift always
        // treats enums as i32 values, I'm changing it to a fatal error.
        // I doubt this will affect many people, but users who run into this
        // will have to update their thrift files to manually specify the
        // truncated i32 value that thrift has always been using anyway.
        driver.failure([&](auto& o) {
          o << "64-bit value supplied for enum " << yystack_[2].value.as < std::string > () << " will be truncated.";
        });
      }
      yylhs.value.as < t_enum_value* > () = new t_enum_value(std::move(yystack_[2].value.as < std::string > ()));
      yylhs.value.as < t_enum_value* > ()->set_value(yystack_[0].value.as < int64_t > ());
      yylhs.value.as < t_enum_value* > ()->set_lineno(driver.scanner->get_lineno());
    }
#line 1984 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 48: // EnumValue: Identifier
#line 601 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier");
      yylhs.value.as < t_enum_value* > () = new t_enum_value(std::move(yystack_[0].value.as < std::string > ()));
      yylhs.value.as < t_enum_value* > ()->set_lineno(driver.scanner->get_lineno());
    }
#line 1994 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 49: // $@4: %empty
#line 609 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Const);
    }
#line 2002 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 50: // Const: DefinitionAttrs tok_const FieldType Identifier $@4 "=" ConstValue TypeAnnotations CommaOrSemicolonOptional
#line 613 "parse/thrifty.yy"
    {
      driver.debug("DefinitionAttrs Const => tok_const FieldType Identifier = ConstValue");
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const* > () = new t_const(driver.program, std::move(yystack_[6].value.as < t_type_ref > ()), std::move(yystack_[5].value.as < std::string > ()), own(yystack_[2].value.as < t_const_value* > ()));
        driver.avoid_last_token_loc(yystack_[8].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[7].location);
        driver.finish_node(
            yylhs.value.as < t_const* > (), LineType::Const, yylhs.location, own(yystack_[8].value.as < t_def_attrs* > ()), own(yystack_[1].value.as < t_annotations* > ()));
      } else {
        // TODO(afuller): Looks like a bug where driver.finish_node is never called in this case.
        delete yystack_[8].value.as < t_def_attrs* > ();
        delete yystack_[2].value.as < t_const_value* > ();
        delete yystack_[1].value.as < t_annotations* > ();
        yylhs.value.as < t_const* > () = nullptr;
      }
    }
#line 2022 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 51: // ConstValue: tok_bool_constant
#line 631 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_int_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_bool(yystack_[0].value.as < int64_t > ());
    }
#line 2032 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 52: // ConstValue: tok_int_constant
#line 637 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_int_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_integer(yystack_[0].value.as < int64_t > ());
      if (driver.mode == parsing_mode::PROGRAM) {
        if (!driver.params.allow_64bit_consts && (yystack_[0].value.as < int64_t > () < INT32_MIN || yystack_[0].value.as < int64_t > () > INT32_MAX)) {
          driver.warning([&](auto& o) {
            o << "64-bit constant \"" << yystack_[0].value.as < int64_t > () << "\" may not work in all languages.";
          });
        }
      }
    }
#line 2049 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 53: // ConstValue: tok_dub_constant
#line 650 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_dub_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_double(yystack_[0].value.as < double > ());
    }
#line 2059 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 54: // ConstValue: tok_literal
#line 656 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_literal");
      yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
    }
#line 2068 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 55: // ConstValue: Identifier
#line 661 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => Identifier");
      const t_const* constant = driver.scope_cache->get_constant(yystack_[0].value.as < std::string > ());
      driver.validate_not_ambiguous_enum(yystack_[0].value.as < std::string > ());
      if (constant == nullptr) {
        auto name_with_program_name = driver.program->name() + "." + yystack_[0].value.as < std::string > ();
        constant = driver.scope_cache->get_constant(name_with_program_name);
        driver.validate_not_ambiguous_enum(name_with_program_name);
      }
      if (constant != nullptr) {
        // Copy const_value to perform isolated mutations
        t_const_value* const_value = constant->get_value();
        yylhs.value.as < t_const_value* > () = const_value->clone().release();

        // We only want to clone the value, while discarding all real type
        // information.
        yylhs.value.as < t_const_value* > ()->set_ttype(boost::none);
        yylhs.value.as < t_const_value* > ()->set_is_enum(false);
        yylhs.value.as < t_const_value* > ()->set_enum(nullptr);
        yylhs.value.as < t_const_value* > ()->set_enum_value(nullptr);
      } else {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning([&](auto& o) {
            o << "Constant strings should be quoted: " << yystack_[0].value.as < std::string > ();
          });
        }
        yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
      }
    }
#line 2102 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 56: // ConstValue: ConstList
#line 691 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstList");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2111 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 57: // ConstValue: ConstMap
#line 696 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstMap");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2120 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 58: // ConstValue: ConstStruct
#line 701 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstStruct");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2129 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 59: // ConstList: "[" ConstListContents CommaOrSemicolonOptional "]"
#line 708 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ConstListContents CommaOrSemicolonOptional ]");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2138 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 60: // ConstList: "[" "]"
#line 713 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ]");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
    }
#line 2148 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 61: // ConstListContents: ConstListContents CommaOrSemicolon ConstValue
#line 721 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstListContents CommaOrSemicolon ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_list(own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2158 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 62: // ConstListContents: ConstValue
#line 727 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
      yylhs.value.as < t_const_value* > ()->add_list(own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2169 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 63: // ConstMap: "{" ConstMapContents CommaOrSemicolonOptional "}"
#line 736 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { ConstMapContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2178 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 64: // ConstMap: "{" "}"
#line 742 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
    }
#line 2188 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 65: // ConstMapContents: ConstMapContents CommaOrSemicolon ConstValue ":" ConstValue
#line 750 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstMapContents CommaOrSemicolon ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(own(yystack_[2].value.as < t_const_value* > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2198 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 66: // ConstMapContents: ConstValue ":" ConstValue
#line 756 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(own(yystack_[2].value.as < t_const_value* > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2209 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 67: // ConstStruct: ConstStructType "{" ConstStructContents CommaOrSemicolonOptional "}"
#line 765 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { ConstStructContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->set_ttype(yystack_[4].value.as < t_type_ref > ());
    }
#line 2219 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 68: // ConstStruct: ConstStructType "{" "}"
#line 771 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->set_ttype(yystack_[2].value.as < t_type_ref > ());
    }
#line 2230 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 69: // ConstStructType: Identifier
#line 780 "parse/thrifty.yy"
    {
      driver.debug("ConstStructType -> Identifier");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(std::move(yystack_[0].value.as < std::string > ()), nullptr, /*is_const=*/true);
    }
#line 2239 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 70: // ConstStructContents: ConstStructContents CommaOrSemicolon Identifier "=" ConstValue
#line 787 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => ConstStructContents CommaOrSemicolon Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2249 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 71: // ConstStructContents: Identifier "=" ConstValue
#line 793 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2260 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 72: // $@5: %empty
#line 802 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Struct);
    }
#line 2268 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 73: // Struct: DefinitionAttrs tok_struct Identifier $@5 "{" FieldList "}" TypeAnnotations
#line 806 "parse/thrifty.yy"
    {
      driver.debug("Struct => DefinitionAttrs tok_struct Identifier "
        "{ FieldList } TypeAnnotations");
      yylhs.value.as < t_struct* > () = new t_struct(driver.program, std::move(yystack_[5].value.as < std::string > ()));
      driver.avoid_last_token_loc(yystack_[7].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[6].location);
      driver.finish_node(
          yylhs.value.as < t_struct* > (), LineType::Struct, yylhs.location, own(yystack_[7].value.as < t_def_attrs* > ()), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2281 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 74: // $@6: %empty
#line 817 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Union);
    }
#line 2289 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 75: // Union: DefinitionAttrs tok_union Identifier $@6 "{" FieldList "}" TypeAnnotations
#line 821 "parse/thrifty.yy"
    {
      driver.debug("Union => DefinitionAttrs tok_union Identifier "
        "{ FieldList } TypeAnnotations");
      yylhs.value.as < t_union* > () = new t_union(driver.program, std::move(yystack_[5].value.as < std::string > ()));
      driver.avoid_last_token_loc(yystack_[7].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[6].location);
      driver.finish_node(
          yylhs.value.as < t_union* > (), LineType::Union, yylhs.location, own(yystack_[7].value.as < t_def_attrs* > ()), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2302 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 76: // $@7: %empty
#line 833 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Exception);
    }
#line 2310 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 77: // Exception: DefinitionAttrs ErrorSafety ErrorKind ErrorBlame tok_exception Identifier $@7 "{" FieldList "}" TypeAnnotations
#line 837 "parse/thrifty.yy"
    {
      driver.debug("Exception => DefinitionAttrs tok_exception "
        "Identifier { FieldList } TypeAnnotations");
      yylhs.value.as < t_exception* > () = new t_exception(driver.program, std::move(yystack_[5].value.as < std::string > ()));
      yylhs.value.as < t_exception* > ()->set_safety(yystack_[9].value.as < t_error_safety > ());
      yylhs.value.as < t_exception* > ()->set_kind(yystack_[8].value.as < t_error_kind > ());
      yylhs.value.as < t_exception* > ()->set_blame(yystack_[7].value.as < t_error_blame > ());
      driver.avoid_last_token_loc(yystack_[10].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[9].location);
      driver.finish_node(
          yylhs.value.as < t_exception* > (), LineType::Exception, yylhs.location, own(yystack_[10].value.as < t_def_attrs* > ()), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));

      const char* annotations[] = {"message", "code"};
      for (auto& annotation: annotations) {
        if (driver.mode == parsing_mode::PROGRAM
            && yylhs.value.as < t_exception* > ()->get_field_by_name(annotation) != nullptr
            && yylhs.value.as < t_exception* > ()->has_annotation(annotation)
            && strcmp(annotation, yylhs.value.as < t_exception* > ()->get_annotation(annotation).c_str()) != 0) {
          driver.warning([&](auto& o) {
            o << "Some generators (e.g. PHP) will ignore annotation '"
              << annotation << "' as it is also used as field";
          });
        }
      }

      // Check that value of "message" annotation is
      // - a valid member of struct
      // - of type STRING
      if (driver.mode == parsing_mode::PROGRAM && yylhs.value.as < t_exception* > ()->has_annotation("message")) {
        const std::string& v = yylhs.value.as < t_exception* > ()->get_annotation("message");
        const auto* field = yylhs.value.as < t_exception* > ()->get_field_by_name(v);
        if (field == nullptr) {
          driver.failure([&](auto& o) {
            o << "member specified as exception 'message' should be a valid"
              << " struct member, '" << v << "' in '" << yylhs.value.as < t_exception* > ()->name() << "' is not";
          });
        }

        if (!field->get_type()->is_string_or_binary()) {
          driver.failure([&](auto& o) {
            o << "member specified as exception 'message' should be of type "
              << "STRING, '" << v << "' in '" << yylhs.value.as < t_exception* > ()->name() << "' is not";
          });
        }
      }
    }
#line 2360 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 78: // ErrorSafety: tok_safe
#line 885 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_safety > () = t_error_safety::safe;
    }
#line 2369 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 79: // ErrorSafety: %empty
#line 890 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_safety > () = {};
    }
#line 2377 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 80: // ErrorKind: tok_transient
#line 896 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::transient;
    }
#line 2386 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 81: // ErrorKind: tok_stateful
#line 902 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::stateful;
    }
#line 2395 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 82: // ErrorKind: tok_permanent
#line 908 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::permanent;
    }
#line 2404 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 83: // ErrorKind: %empty
#line 913 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_kind > () = {};
    }
#line 2412 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 84: // ErrorBlame: tok_client
#line 919 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_blame > () = t_error_blame::client;
    }
#line 2421 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 85: // ErrorBlame: tok_server
#line 925 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_blame > () = t_error_blame::server;
    }
#line 2430 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 86: // ErrorBlame: %empty
#line 930 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_blame > () = {};
    }
#line 2438 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 87: // $@8: %empty
#line 937 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Service);
    }
#line 2446 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 88: // Service: DefinitionAttrs tok_service Identifier $@8 Extends "{" FlagArgs FunctionList UnflagArgs "}" FunctionAnnotations
#line 941 "parse/thrifty.yy"
    {
      driver.debug("Service => DefinitionAttrs tok_service "
        "Identifier Extends { FlagArgs FunctionList UnflagArgs } "
        "FunctionAnnotations");
      yylhs.value.as < t_service* > () = new t_service(driver.program, std::move(yystack_[8].value.as < std::string > ()), yystack_[6].value.as < t_ref<t_service> > ());
      driver.avoid_last_token_loc(yystack_[10].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[9].location);
      driver.finish_node(
          yylhs.value.as < t_service* > (), LineType::Service, yylhs.location, own(yystack_[10].value.as < t_def_attrs* > ()), own(yystack_[3].value.as < t_function_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2460 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 89: // FlagArgs: %empty
#line 952 "parse/thrifty.yy"
    {
       g_arglist = 1;
    }
#line 2468 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 90: // UnflagArgs: %empty
#line 957 "parse/thrifty.yy"
    {
       g_arglist = 0;
    }
#line 2476 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 91: // Extends: tok_extends Identifier
#line 963 "parse/thrifty.yy"
    {
      driver.debug("Extends -> tok_extends Identifier");
      yylhs.value.as < t_ref<t_service> > () = nullptr;
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_ref<t_service> > () = driver.scope_cache->get_service(yystack_[0].value.as < std::string > ());
        if (!yylhs.value.as < t_ref<t_service> > ()) {
          yylhs.value.as < t_ref<t_service> > () = driver.scope_cache->get_service(driver.program->name() + "." + yystack_[0].value.as < std::string > ());
        }
        if (!yylhs.value.as < t_ref<t_service> > ()) {
          driver.failure([&](auto& o) {
            o << "Service \"" << yystack_[0].value.as < std::string > () << "\" has not been defined.";
          });
        }
      }
    }
#line 2496 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 92: // Extends: %empty
#line 979 "parse/thrifty.yy"
    {
      yylhs.value.as < t_ref<t_service> > () = nullptr;
    }
#line 2504 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 93: // $@9: %empty
#line 985 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Interaction);
    }
#line 2512 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 94: // Interaction: DefinitionAttrs tok_interaction Identifier $@9 "{" FlagArgs FunctionList UnflagArgs "}" TypeAnnotations
#line 989 "parse/thrifty.yy"
    {
      driver.debug("Interaction -> tok_interaction Identifier { FunctionList }");
      yylhs.value.as < t_interaction* > () = new t_interaction(driver.program, std::move(yystack_[7].value.as < std::string > ()));
      driver.avoid_last_token_loc(yystack_[9].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[8].location);
      driver.finish_node(
          yylhs.value.as < t_interaction* > (), LineType::Interaction, yylhs.location, own(yystack_[9].value.as < t_def_attrs* > ()), own(yystack_[3].value.as < t_function_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));

      // TODO(afuller): Move this to a post parse phase.
      for (auto* func : yylhs.value.as < t_interaction* > ()->get_functions()) {
        func->set_is_interaction_member();
        if (func->has_annotation("thread")) {
          driver.failure("Interaction methods cannot be individually annotated with "
            "thread='eb'. Use process_in_event_base on the interaction instead.");
        }
      }
      if (yylhs.value.as < t_interaction* > ()->has_annotation("process_in_event_base")) {
        if (yylhs.value.as < t_interaction* > ()->has_annotation("serial")) {
          driver.failure("EB interactions are already serial");
        }
        for (auto* func : yylhs.value.as < t_interaction* > ()->get_functions()) {
          func->set_annotation("thread", "eb");
        }
      }
    }
#line 2541 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 95: // FunctionList: FunctionList Function
#line 1016 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> FunctionList Function");
      yystack_[1].value.as < t_function_list* > ()->emplace_back(own(yystack_[0].value.as < t_function* > ()));
      yylhs.value.as < t_function_list* > () = yystack_[1].value.as < t_function_list* > ();
    }
#line 2551 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 96: // FunctionList: %empty
#line 1022 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> ");
      yylhs.value.as < t_function_list* > () = new t_function_list;
    }
#line 2560 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 97: // $@10: %empty
#line 1029 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Function);
    }
#line 2568 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 98: // Function: DefinitionAttrs FunctionQualifier FunctionType Identifier $@10 "(" ParamList ")" MaybeThrows FunctionAnnotations CommaOrSemicolonOptional
#line 1033 "parse/thrifty.yy"
    {
      driver.debug("Function => DefinitionAttrs FunctionQualifier "
        "FunctionType Identifier ( ParamList ) MaybeThrows "
        "FunctionAnnotations CommaOrSemicolonOptional");
      // TODO(afuller): Leave the param list unnamed.
      yystack_[4].value.as < t_paramlist* > ()->set_name(std::string(yystack_[7].value.as < std::string > ()) + "_args");
      auto func = std::make_unique<t_function>(std::move(yystack_[8].value.as < t_type_ref > ()), std::move(yystack_[7].value.as < std::string > ()), own(yystack_[4].value.as < t_paramlist* > ()), yystack_[9].value.as < t_function_qualifier > ());
      func->set_exceptions(own(yystack_[2].value.as < t_throws* > ()));

      driver.avoid_last_token_loc(yystack_[10].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[9].location);
      driver.avoid_next_token_loc(yystack_[1].value.as < t_annotations* > () == nullptr, yylhs.location, yystack_[2].location);
      driver.finish_node(
          func.get(), LineType::Function, yylhs.location, own(yystack_[10].value.as < t_def_attrs* > ()), own(yystack_[1].value.as < t_annotations* > ()));
      yylhs.value.as < t_function* > () = func.release();
    }
#line 2588 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 99: // Function: tok_performs FieldType ";"
#line 1049 "parse/thrifty.yy"
    {
      driver.debug("Function => tok_performs FieldType");
      auto& ret = yystack_[1].value.as < t_type_ref > ();
      std::string name = ret.get_type()
          ? "create" + ret.get_type()->get_name()
          : "<interaction placeholder>";
      yylhs.value.as < t_function* > () = new t_function(
        std::move(ret),
        std::move(name),
        std::make_unique<t_paramlist>(driver.program)
      );
      yylhs.value.as < t_function* > ()->set_lineno(driver.scanner->get_lineno());
      yylhs.value.as < t_function* > ()->set_is_interaction_constructor();
    }
#line 2607 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 100: // ParamList: ParamList Param
#line 1066 "parse/thrifty.yy"
    {
      driver.debug("ParamList -> ParamList , Param");
      yylhs.value.as < t_paramlist* > () = yystack_[1].value.as < t_paramlist* > ();
      auto param = own(yystack_[0].value.as < t_field* > ());
      if (!yylhs.value.as < t_paramlist* > ()->try_append_field(std::move(param))) {
        driver.failure([&](auto& o) {
          o << "Parameter identifier " << param->get_key() << " for \""
          << param->get_name() << "\" has already been used";
        });
      }
    }
#line 2623 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 101: // ParamList: EmptyParamList
#line 1078 "parse/thrifty.yy"
    {
      yylhs.value.as < t_paramlist* > () = yystack_[0].value.as < t_paramlist* > ();
    }
#line 2631 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 102: // EmptyParamList: %empty
#line 1083 "parse/thrifty.yy"
    {
      driver.debug("EmptyParamList -> nil");
      yylhs.value.as < t_paramlist* > () = new t_paramlist(driver.program);
    }
#line 2640 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 103: // Param: Field
#line 1090 "parse/thrifty.yy"
    {
      driver.debug("Param -> Field");
      yylhs.value.as < t_field* > () = yystack_[0].value.as < t_field* > ();
    }
#line 2649 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 104: // FunctionQualifier: tok_oneway
#line 1097 "parse/thrifty.yy"
    {
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::one_way;
    }
#line 2657 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 105: // FunctionQualifier: tok_idempotent
#line 1101 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("idempotency");
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::idempotent;
    }
#line 2666 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 106: // FunctionQualifier: tok_readonly
#line 1106 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("idempotency");
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::read_only;
    }
#line 2675 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 107: // FunctionQualifier: %empty
#line 1111 "parse/thrifty.yy"
    {
      yylhs.value.as < t_function_qualifier > () = {};
    }
#line 2683 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 108: // MaybeThrows: tok_throws "(" FieldList ")"
#line 1117 "parse/thrifty.yy"
    {
      driver.debug("MaybeThrows -> tok_throws ( FieldList )");
      yylhs.value.as < t_throws* > () = driver.new_throws(own(yystack_[1].value.as < t_field_list* > ())).release();
    }
#line 2692 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 109: // MaybeThrows: %empty
#line 1121 "parse/thrifty.yy"
    {
      driver.debug("MaybeThrows -> ");
      yylhs.value.as < t_throws* > () = nullptr;
		}
#line 2701 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 110: // FieldList: FieldList Field
#line 1128 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> FieldList Field");
      yylhs.value.as < t_field_list* > () = yystack_[1].value.as < t_field_list* > ();
      yylhs.value.as < t_field_list* > ()->emplace_back(yystack_[0].value.as < t_field* > ());
    }
#line 2711 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 111: // FieldList: %empty
#line 1134 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> ");
      yylhs.value.as < t_field_list* > () = new t_field_list;
    }
#line 2720 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 112: // $@11: %empty
#line 1141 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Field);
    }
#line 2728 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 113: // Field: DefinitionAttrs FieldIdentifier FieldQualifier FieldType Identifier $@11 FieldValue TypeAnnotations CommaOrSemicolonOptional
#line 1145 "parse/thrifty.yy"
    {
      driver.debug("Field => DefinitionAttrs FieldIdentifier FieldQualifier "
        "FieldType Identifier FieldValue TypeAnnotations CommaOrSemicolonOptional");
      t_field_id id;
      if (yystack_[7].value.as < boost::optional<t_field_id> > () == boost::none) {
        // Auto assign an id.
        id = driver.allocate_field_id(yystack_[4].value.as < std::string > ());
      } else {
        id = *yystack_[7].value.as < boost::optional<t_field_id> > ();
        if (id <= 0) {
          // TODO(afuller): Move this validation to ast_validator.
          if (driver.params.allow_neg_field_keys) {
            /*
              * allow_neg_field_keys exists to allow users to add explicitly
              * specified id values to old .thrift files without breaking
              * protocol compatibility.
              */
            if (id != driver.next_field_id()) {
              /*
                * warn if the user-specified negative value isn't what
                * thrift would have auto-assigned.
                */
              driver.warning([&](auto& o) {
                o << "Nonpositive field id (" << id << ") differs from what would "
                  << "be auto-assigned by thrift (" << driver.next_field_id() << ").";
              });
            }
          } else if (id == driver.next_field_id()) {
            driver.warning([&](auto& o) {
              o << "Nonpositive value (" << id << ") not allowed as a field id.";
            });
          } else {
            // TODO(afuller): Make ignoring the user provided value a failure.
            driver.warning([&](auto& o) {
              o << "Nonpositive field id (" << id<< ") differs from what is auto-"
                  "assigned by thrift. The id must positive or " << driver.next_field_id() << ".";
            });
            // Ignore user provided value and auto assign an id.
            id = driver.allocate_field_id(yystack_[4].value.as < std::string > ());
            yystack_[7].value.as < boost::optional<t_field_id> > () = boost::none;
          }
          driver.reserve_field_id(id);
        }
      }
      yylhs.value.as < t_field* > () = new t_field(std::move(yystack_[5].value.as < t_type_ref > ()), std::move(yystack_[4].value.as < std::string > ()), id, yystack_[7].value.as < boost::optional<t_field_id> > () != boost::none);
      yylhs.value.as < t_field* > ()->set_qualifier(yystack_[6].value.as < t_field_qualifier > ());
      if (yystack_[2].value.as < t_const_value* > () != nullptr) {
        yylhs.value.as < t_field* > ()->set_default_value(own(yystack_[2].value.as < t_const_value* > ()));
      }
      driver.avoid_last_token_loc(yystack_[8].value.as < t_def_attrs* > () == nullptr, yylhs.location, yystack_[7].location);
      driver.finish_node(
          yylhs.value.as < t_field* > (), LineType::Field, yylhs.location, own(yystack_[8].value.as < t_def_attrs* > ()), own(yystack_[1].value.as < t_annotations* > ()));
    }
#line 2786 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 114: // FieldIdentifier: tok_int_constant ":"
#line 1201 "parse/thrifty.yy"
    {
      yylhs.value.as < boost::optional<t_field_id> > () = driver.as_field_id(yystack_[1].value.as < int64_t > ());
    }
#line 2794 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 115: // FieldIdentifier: %empty
#line 1205 "parse/thrifty.yy"
    {
      yylhs.value.as < boost::optional<t_field_id> > () = boost::none;
    }
#line 2802 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 116: // FieldQualifier: tok_required
#line 1211 "parse/thrifty.yy"
    {
      if (g_arglist) {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning("required keyword is ignored in argument lists.");
        }
        yylhs.value.as < t_field_qualifier > () = {};
      } else {
        yylhs.value.as < t_field_qualifier > () = t_field_qualifier::required;
      }
    }
#line 2817 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 117: // FieldQualifier: tok_optional
#line 1222 "parse/thrifty.yy"
    {
      if (g_arglist) {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning("optional keyword is ignored in argument lists.");
        }
        yylhs.value.as < t_field_qualifier > () = {};
      } else {
        yylhs.value.as < t_field_qualifier > () = t_field_qualifier::optional;
      }
    }
#line 2832 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 118: // FieldQualifier: %empty
#line 1233 "parse/thrifty.yy"
    {
      yylhs.value.as < t_field_qualifier > () = {};
    }
#line 2840 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 119: // FieldValue: "=" ConstValue
#line 1239 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
      } else {
        delete yystack_[0].value.as < t_const_value* > ();
        yylhs.value.as < t_const_value* > () = nullptr;
      }
    }
#line 2853 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 120: // FieldValue: %empty
#line 1248 "parse/thrifty.yy"
    {
      yylhs.value.as < t_const_value* > () = nullptr;
    }
#line 2861 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 121: // FunctionType: ResponseAndStreamReturnType
#line 1254 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> ResponseAndStreamReturnType");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(own(yystack_[0].value.as < t_stream_response* > ()), nullptr);
    }
#line 2870 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 122: // FunctionType: ResponseAndSinkReturnType
#line 1259 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> ResponseAndSinkReturnType");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(own(yystack_[0].value.as < t_sink* > ()), nullptr);
    }
#line 2879 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 123: // FunctionType: FieldType
#line 1264 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType");
      yylhs.value.as < t_type_ref > () = yystack_[0].value.as < t_type_ref > ();
    }
#line 2888 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 124: // FunctionType: tok_void
#line 1269 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> tok_void");
      yylhs.value.as < t_type_ref > () = t_base_type::t_void();
    }
#line 2897 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 125: // ResponseAndStreamReturnType: FieldType "," StreamReturnType
#line 1276 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndStreamReturnType -> FieldType, StreamReturnType");
      yystack_[0].value.as < t_stream_response* > ()->set_first_response_type(std::move(yystack_[2].value.as < t_type_ref > ()));
      yylhs.value.as < t_stream_response* > () = yystack_[0].value.as < t_stream_response* > ();
    }
#line 2907 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 126: // ResponseAndStreamReturnType: StreamReturnType
#line 1282 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndStreamReturnType -> StreamReturnType");
      yylhs.value.as < t_stream_response* > () = yystack_[0].value.as < t_stream_response* > ();
    }
#line 2916 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 127: // StreamReturnType: tok_stream "<" FieldType MaybeThrows ">"
#line 1289 "parse/thrifty.yy"
  {
    driver.debug("StreamReturnType -> tok_stream < FieldType MaybeThrows >");
    auto stream_res = std::make_unique<t_stream_response>(std::move(yystack_[2].value.as < t_type_ref > ()));
    stream_res->set_exceptions(own(yystack_[1].value.as < t_throws* > ()));
    yylhs.value.as < t_stream_response* > () = stream_res.release();
  }
#line 2927 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 128: // ResponseAndSinkReturnType: FieldType "," SinkReturnType
#line 1298 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndSinkReturnType -> FieldType, SinkReturnType");
      yystack_[0].value.as < t_sink* > ()->set_first_response_type(std::move(yystack_[2].value.as < t_type_ref > ()));
      yylhs.value.as < t_sink* > () = yystack_[0].value.as < t_sink* > ();
    }
#line 2937 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 129: // ResponseAndSinkReturnType: SinkReturnType
#line 1304 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndSinkReturnType -> SinkReturnType");
      yylhs.value.as < t_sink* > () = yystack_[0].value.as < t_sink* > ();
    }
#line 2946 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 130: // SinkReturnType: tok_sink "<" SinkFieldType "," SinkFieldType ">"
#line 1311 "parse/thrifty.yy"
    {
      driver.debug("SinkReturnType -> tok_sink<FieldType, FieldType>");
      auto sink = std::make_unique<t_sink>(std::move(yystack_[3].value.as < t_typethrowspair > ().first), std::move(yystack_[1].value.as < t_typethrowspair > ().first));
      sink->set_sink_exceptions(own(yystack_[3].value.as < t_typethrowspair > ().second));
      sink->set_final_response_exceptions(own(yystack_[1].value.as < t_typethrowspair > ().second));
      yylhs.value.as < t_sink* > () = sink.release();
    }
#line 2958 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 131: // SinkFieldType: FieldType MaybeThrows
#line 1321 "parse/thrifty.yy"
    {
      yylhs.value.as < t_typethrowspair > () = std::make_pair(yystack_[1].value.as < t_type_ref > (), yystack_[0].value.as < t_throws* > ());
    }
#line 2966 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 132: // FieldType: Identifier TypeAnnotations
#line 1327 "parse/thrifty.yy"
    {
      driver.debug("FieldType => Identifier TypeAnnotations");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(std::move(yystack_[1].value.as < std::string > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2975 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 133: // FieldType: BaseType TypeAnnotations
#line 1332 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> BaseType");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(*yystack_[1].value.as < t_ref<t_base_type> > (), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2984 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 134: // FieldType: ContainerType TypeAnnotations
#line 1337 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> ContainerType");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(own(yystack_[1].value.as < t_container* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2993 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 135: // BaseType: tok_string
#line 1344 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_string");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_string();
    }
#line 3002 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 136: // BaseType: tok_binary
#line 1349 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_binary");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_binary();
    }
#line 3011 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 137: // BaseType: tok_bool
#line 1354 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_bool");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_bool();
    }
#line 3020 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 138: // BaseType: tok_byte
#line 1359 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_byte");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_byte();
    }
#line 3029 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 139: // BaseType: tok_i16
#line 1364 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i16");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i16();
    }
#line 3038 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 140: // BaseType: tok_i32
#line 1369 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i32");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i32();
    }
#line 3047 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 141: // BaseType: tok_i64
#line 1374 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i64");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i64();
    }
#line 3056 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 142: // BaseType: tok_double
#line 1379 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_double");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_double();
    }
#line 3065 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 143: // BaseType: tok_float
#line 1384 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_float");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_float();
    }
#line 3074 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 144: // ContainerType: MapType
#line 1391 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> MapType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3083 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 145: // ContainerType: SetType
#line 1396 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> SetType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3092 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 146: // ContainerType: ListType
#line 1401 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> ListType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3101 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 147: // MapType: tok_map "<" FieldType "," FieldType ">"
#line 1408 "parse/thrifty.yy"
    {
      driver.debug("MapType -> tok_map<FieldType, FieldType>");
      yylhs.value.as < t_container* > () = new t_map(std::move(yystack_[3].value.as < t_type_ref > ()), std::move(yystack_[1].value.as < t_type_ref > ()));
    }
#line 3110 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 148: // SetType: tok_set "<" FieldType ">"
#line 1415 "parse/thrifty.yy"
    {
      driver.debug("SetType -> tok_set<FieldType>");
      yylhs.value.as < t_container* > () = new t_set(std::move(yystack_[1].value.as < t_type_ref > ()));
    }
#line 3119 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 149: // ListType: tok_list "<" FieldType ">"
#line 1422 "parse/thrifty.yy"
    {
      driver.debug("ListType -> tok_list<FieldType>");
      yylhs.value.as < t_container* > () = new t_list(std::move(yystack_[1].value.as < t_type_ref > ()));
    }
#line 3128 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 150: // $@12: %empty
#line 1429 "parse/thrifty.yy"
    {
      yystack_[1].value.as < t_annotations* > ()->last_lineno = driver.scanner->get_lineno();
    }
#line 3136 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 151: // TypeAnnotations: "(" TypeAnnotationList CommaOrSemicolonOptional $@12 ")"
#line 1433 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations => ( TypeAnnotationList CommaOrSemicolonOptional)");
      yylhs.value.as < t_annotations* > () = yystack_[3].value.as < t_annotations* > ();
    }
#line 3145 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 152: // TypeAnnotations: "(" ")"
#line 1438 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations => ( )");
      yylhs.value.as < t_annotations* > () = nullptr;
    }
#line 3154 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 153: // TypeAnnotations: %empty
#line 1443 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations =>");
      yylhs.value.as < t_annotations* > () = nullptr;
    }
#line 3163 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 154: // TypeAnnotationList: TypeAnnotationList CommaOrSemicolon TypeAnnotation
#line 1450 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationList => TypeAnnotationList CommaOrSemicolon TypeAnnotation");
      yylhs.value.as < t_annotations* > () = yystack_[2].value.as < t_annotations* > ();
      yylhs.value.as < t_annotations* > ()->strings[yystack_[0].value.as < t_annotation* > ()->first] = std::move(yystack_[0].value.as < t_annotation* > ()->second);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3174 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 155: // TypeAnnotationList: TypeAnnotation
#line 1457 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationList => TypeAnnotation");
      /* Just use a dummy structure to hold the annotations. */
      yylhs.value.as < t_annotations* > () = new t_annotations();
      yylhs.value.as < t_annotations* > ()->strings[yystack_[0].value.as < t_annotation* > ()->first] = std::move(yystack_[0].value.as < t_annotation* > ()->second);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3186 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 156: // TypeAnnotation: Identifier "=" IntOrLiteral
#line 1467 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotation -> Identifier = IntOrLiteral");
      yylhs.value.as < t_annotation* > () = new t_annotation{yystack_[2].value.as < std::string > (), {driver.get_source_range(yylhs.location), yystack_[0].value.as < std::string > ()}};
    }
#line 3195 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 157: // TypeAnnotation: Identifier
#line 1472 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotation -> Identifier");
      yylhs.value.as < t_annotation* > () = new t_annotation{yystack_[0].value.as < std::string > (), {driver.get_source_range(yylhs.location), "1"}};
    }
#line 3204 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 158: // StructuredAnnotations: NonEmptyStructuredAnnotationList
#line 1479 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations -> NonEmptyStructuredAnnotationList");
      yylhs.value.as < t_struct_annotations* > () = yystack_[0].value.as < t_struct_annotations* > ();
    }
#line 3213 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 159: // StructuredAnnotations: %empty
#line 1484 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations ->");
      yylhs.value.as < t_struct_annotations* > () = nullptr;
    }
#line 3222 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 160: // NonEmptyStructuredAnnotationList: NonEmptyStructuredAnnotationList StructuredAnnotation
#line 1491 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList -> NonEmptyStructuredAnnotationList StructuredAnnotation");
      yylhs.value.as < t_struct_annotations* > () = yystack_[1].value.as < t_struct_annotations* > ();
      yylhs.value.as < t_struct_annotations* > ()->emplace_back(yystack_[0].value.as < t_const* > ());
    }
#line 3232 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 161: // NonEmptyStructuredAnnotationList: StructuredAnnotation
#line 1497 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList ->");
      yylhs.value.as < t_struct_annotations* > () = new t_struct_annotations;
      yylhs.value.as < t_struct_annotations* > ()->emplace_back(yystack_[0].value.as < t_const* > ());
    }
#line 3242 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 162: // StructuredAnnotation: "@" ConstStruct
#line 1505 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStruct");
      yylhs.value.as < t_const* > () = driver.new_struct_annotation(own(yystack_[0].value.as < t_const_value* > ())).release();
    }
#line 3251 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 163: // StructuredAnnotation: "@" ConstStructType
#line 1510 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStructType");
      auto value = std::make_unique<t_const_value>();
      value->set_map();
      value->set_ttype(std::move(yystack_[0].value.as < t_type_ref > ()));
      yylhs.value.as < t_const* > () = driver.new_struct_annotation(std::move(value)).release();
    }
#line 3263 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 164: // FunctionAnnotations: TypeAnnotations
#line 1520 "parse/thrifty.yy"
    {
      driver.debug("FunctionAnnotations => TypeAnnotations");
      if (!yystack_[0].value.as < t_annotations* > ()) {
        yylhs.value.as < t_annotations* > () = nullptr;
        break;
      }
      yylhs.value.as < t_annotations* > () = yystack_[0].value.as < t_annotations* > ();
      auto priority = yylhs.value.as < t_annotations* > ()->strings.find("priority");
      if (priority == yylhs.value.as < t_annotations* > ()->strings.end()) {
        break;
      }
      const std::string& prio = priority->second.value;
      const std::string prio_list[] = {"HIGH_IMPORTANT", "HIGH", "IMPORTANT",
                                       "NORMAL", "BEST_EFFORT"};
      const auto end = prio_list + sizeof(prio_list)/sizeof(prio_list[0]);
      if (std::find(prio_list, end, prio) == end) {
        std::string s;
        for (const auto& prio : prio_list) {
          s += prio + "','";
        }
        s.erase(s.length() - 3);
        driver.failure([&](auto& o) {
          o << "Bad priority '" << prio << "'. Choose one of '" << s << "'.";
        });
      }
    }
#line 3294 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 165: // IntOrLiteral: tok_literal
#line 1549 "parse/thrifty.yy"
    {
      driver.debug("IntOrLiteral -> tok_literal");
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 3303 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 166: // IntOrLiteral: tok_bool_constant
#line 1555 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_bool_constant");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3314 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 167: // IntOrLiteral: tok_int_constant
#line 1563 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_int_constant");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3325 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;


#line 3329 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

#if YYDEBUG || 0
  const char *
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if YYDEBUG || 0





  const short parser::yypact_ninf_ = -253;

  const signed char parser::yytable_ninf_ = -91;

  const short
  parser::yypact_[] =
  {
    -253,     9,    -2,  -253,    10,    36,    48,   362,    50,    58,
    -253,  -253,    19,    87,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,    52,  -253,  -253,   362,  -253,
      19,  -253,  -253,   275,   362,   362,   362,   275,   362,   362,
     -29,  -253,  -253,  -253,  -253,    53,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -253,  -253,  -253,    51,    54,    55,    59,
     362,    59,    59,  -253,  -253,  -253,  -253,  -253,  -253,   362,
    -253,  -253,  -253,  -253,  -253,   -19,   342,   275,   275,   275,
     352,  -253,  -253,  -253,  -253,    56,    15,    60,  -253,    64,
      67,  -253,  -253,    30,  -253,    72,    34,    79,    69,    70,
    -253,    89,    34,  -253,    59,  -253,   362,    93,  -253,    92,
    -253,  -253,   362,   332,  -253,  -253,   362,    94,   275,  -253,
    -253,    20,   362,  -253,  -253,   100,  -253,  -253,   101,   332,
     102,  -253,  -253,  -253,  -253,  -253,  -253,   195,   285,   106,
    -253,  -253,  -253,  -253,    53,   105,  -253,   103,  -253,  -253,
    -253,  -253,  -253,   104,    59,   113,  -253,  -253,    59,   362,
    -253,    59,    59,    -5,   110,  -253,   108,    34,  -253,  -253,
      34,   332,  -253,  -253,  -253,   114,     0,    -5,  -253,   116,
    -253,    34,  -253,   275,     8,   121,  -253,  -253,   332,   332,
     122,   332,   111,  -253,  -253,  -253,  -253,   275,   124,   132,
      59,  -253,  -253,   135,  -253,  -253,  -253,   228,    59,   134,
    -253,   136,  -253,  -253,  -253,   362,    59,  -253,    34,  -253,
    -253,   131,   137,   362,  -253,  -253,  -253,  -253,   145,  -253,
      59,   332,  -253,  -253,  -253,  -253,   275,   275,  -253,    21,
    -253,  -253,   142,   107,   149,   107,   144,   137,  -253,  -253,
     332,    59,   146,   139,   275,  -253,  -253,  -253,    34,  -253,
    -253,   147,   148,  -253,  -253,   151,  -253,   107,  -253,  -253,
    -253,    59,    34,  -253
  };

  const unsigned char
  parser::yydefact_[] =
  {
      17,     0,    26,     1,     0,    14,     0,     0,     0,     0,
      16,    18,   159,    79,    25,    28,    29,    27,    30,    31,
      32,    33,    34,    23,     3,     4,     5,     7,     6,     8,
       9,    10,    11,    12,    13,     0,    21,    22,     0,    24,
     158,   161,    78,     0,     0,     0,     0,     0,     0,     0,
      83,    20,    19,    69,   162,   163,   160,   137,   138,   135,
     136,   139,   140,   141,   142,   143,     0,     0,     0,   153,
       0,   153,   153,   144,   145,   146,    72,    87,    41,     0,
      74,    93,    80,    81,    82,    86,     0,     0,     0,     0,
       0,   132,    35,   133,   134,     0,    92,     0,    49,     0,
       0,    85,    84,     0,    68,     0,    40,     0,     0,     0,
     152,   157,    40,   155,   153,   111,     0,     0,    44,     0,
     111,    89,     0,     0,    37,    38,    39,     0,     0,   149,
     148,     0,    39,   150,    36,    14,    91,    89,    14,     0,
      14,    96,    76,    54,    51,    52,    53,     0,     0,    55,
      71,    56,    57,    58,     0,     0,    67,     0,   165,   166,
     167,   156,   154,     0,   153,   115,   110,    96,   153,     0,
      43,   153,   153,    14,     0,    64,     0,    40,    60,    62,
      40,     0,   147,   151,    73,     0,   118,    14,    42,    48,
      45,    40,    75,     0,   107,     0,    95,   111,     0,    39,
       0,    39,     0,    70,   114,   116,   117,     0,     0,     0,
     153,    39,    50,     0,   104,   105,   106,     0,   153,    14,
      66,     0,    63,    61,    59,     0,   153,    47,    40,    99,
     124,     0,     4,     0,   121,   126,   122,   129,   123,    94,
     153,     0,   112,   164,    88,    46,     0,     0,    97,     0,
      77,    65,   120,   109,     0,   109,     0,     0,   125,   128,
       0,   153,     0,     0,     0,   131,   102,   119,    40,   111,
     127,     0,    14,   101,   113,    14,   130,   109,   100,   103,
     108,   153,    40,    98
  };

  const short
  parser::yypgoto_[] =
  {
    -253,  -253,    -7,  -253,  -253,  -253,  -253,  -253,    -3,  -253,
    -253,  -253,  -253,   -93,  -100,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,  -253,  -133,  -253,  -253,  -253,  -253,   126,   133,
    -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,  -253,
    -253,  -253,    35,   -14,  -253,  -253,  -253,    11,  -253,  -253,
    -253,  -253,  -253,  -253,  -252,  -116,   -96,  -253,  -253,  -253,
    -253,  -253,  -253,   -72,  -253,   -69,   -83,   -42,  -253,  -253,
    -253,  -253,  -253,   -61,  -253,  -253,    57,  -253,  -253,   143,
     -95,  -253
  };

  const short
  parser::yydefgoto_[] =
  {
       0,     1,    69,    12,     4,     2,    10,    11,   165,     5,
      14,    15,   114,   211,   127,    16,    97,   138,   170,   210,
     190,    17,   119,   150,   151,   180,   152,   177,   153,   154,
     106,    18,    95,    19,    99,    20,   174,    50,    85,   103,
      21,    96,   141,   195,   117,    22,   100,   173,   196,   256,
     272,   273,   278,   217,   263,   135,   166,   252,   186,   207,
     261,   233,   234,   235,   236,   237,   254,   255,    71,    72,
      73,    74,    75,   243,   163,   112,   113,    39,    40,    41,
     244,   161
  };

  const short
  parser::yytable_[] =
  {
      35,    70,    13,   265,   140,    79,   171,   -90,    91,     3,
      93,    94,   133,   126,   176,   179,    82,    83,    84,   132,
     -15,   -15,   -15,   -15,   158,   281,   159,   160,    52,   101,
     102,    53,     6,     7,     8,     9,    -2,    76,    77,    78,
      38,    80,    81,   124,   125,   107,   108,   109,   203,   214,
     215,   216,    23,   134,    36,    24,    51,   193,   205,   206,
     231,   257,    37,    92,    86,   220,   221,   115,   223,   116,
      87,   118,    98,    88,    89,   120,    90,   200,   121,   105,
     202,   219,   122,   111,   199,   123,   157,   201,   128,   129,
     130,   212,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,   131,   184,   137,   139,   156,   188,   251,   136,
     191,   192,   164,   168,   172,   142,   149,   -69,   181,   155,
     185,   197,   183,   182,   198,   111,   224,   267,   245,   209,
     204,    42,   149,   218,   222,   169,   226,    43,    44,   227,
     149,   149,    45,    46,    47,   229,   240,    48,    49,   228,
     246,   213,   241,   275,   249,   260,   247,   239,   264,   270,
     262,   266,   189,   269,    54,   225,   277,   276,   274,   280,
     194,    55,   167,   208,   149,   238,   279,   258,   187,   250,
     259,   271,   283,    56,   194,     0,   282,     0,     0,   162,
       0,   149,   149,     0,   149,     0,     0,     0,    24,   143,
     268,   144,   145,   146,   253,     0,   147,   175,     0,   148,
       0,     0,     0,     0,     0,     0,     0,     0,   242,     0,
       0,     0,     0,     0,     0,     0,   248,     0,     0,     0,
       0,    24,     0,     0,   149,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,     0,     0,     0,     0,     0,
       0,     0,     0,   149,   230,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,   231,   232,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    24,   143,
       0,   144,   145,   146,     0,     0,   147,     0,     0,   148,
     178,     0,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,     0,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    24,   143,     0,   144,   145,
     146,     0,     0,   147,     0,    24,   148,     0,     0,     0,
       0,     0,     0,     0,   104,    24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    24,     0,     0,     0,     0,
     110,     0,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34
  };

  const short
  parser::yycheck_[] =
  {
       7,    43,     5,   255,   120,    47,   139,    12,    69,     0,
      71,    72,   112,   106,   147,   148,    45,    46,    47,   112,
      22,    23,    24,    25,     4,   277,     6,     7,    35,    48,
      49,    38,    22,    23,    24,    25,     0,    44,    45,    46,
      21,    48,    49,     9,    10,    87,    88,    89,   181,    41,
      42,    43,     4,   114,     4,     3,     4,    62,    58,    59,
      39,    40,     4,    70,    11,   198,   199,    11,   201,    54,
      19,    11,    79,    19,    19,    11,    17,   177,    11,    86,
     180,   197,    52,    90,   177,    13,   128,   180,     9,    20,
      20,   191,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    13,   164,    11,    13,    12,   168,   241,   116,
     171,   172,    12,    12,    12,   122,   123,    11,    13,   126,
       7,    11,    18,    20,    16,   132,    15,   260,   228,    13,
      16,    44,   139,    12,    12,   138,    12,    50,    51,     7,
     147,   148,    55,    56,    57,    10,    12,    60,    61,   210,
      19,   193,    16,   269,     9,    13,    19,   218,     9,    20,
      53,    17,   169,    17,    38,   207,    18,    20,   268,    18,
     173,    38,   137,   187,   181,   217,   272,   249,   167,   240,
     249,   264,   282,    40,   187,    -1,   281,    -1,    -1,   132,
      -1,   198,   199,    -1,   201,    -1,    -1,    -1,     3,     4,
     261,     6,     7,     8,   246,    -1,    11,    12,    -1,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,     3,    -1,    -1,   241,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   260,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
      -1,     6,     7,     8,    -1,    -1,    11,    -1,    -1,    14,
      15,    -1,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,     3,     4,    -1,     6,     7,
       8,    -1,    -1,    11,    -1,     3,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    12,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      18,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,    64,    68,     0,    67,    72,    22,    23,    24,    25,
      69,    70,    66,    71,    73,    74,    78,    84,    94,    96,
      98,   103,   108,     4,     3,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    65,     4,     4,    21,   140,
     141,   142,    44,    50,    51,    55,    56,    57,    60,    61,
     100,     4,    65,    65,    91,    92,   142,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    65,
     130,   131,   132,   133,   134,   135,    65,    65,    65,   130,
      65,    65,    45,    46,    47,   101,    11,    19,    19,    19,
      17,   136,    65,   136,   136,    95,   104,    79,    65,    97,
     109,    48,    49,   102,    12,    65,    93,   130,   130,   130,
      18,    65,   138,   139,    75,    11,    54,   107,    11,    85,
      11,    11,    52,    13,     9,    10,    76,    77,     9,    20,
      20,    13,    76,    77,   136,   118,    65,    11,    80,    13,
     118,   105,    65,     4,     6,     7,     8,    11,    14,    65,
      86,    87,    89,    91,    92,    65,    12,   130,     4,     6,
       7,   144,   139,   137,    12,    71,   119,   105,    12,    71,
      81,    86,    12,   110,    99,    12,    86,    90,    15,    86,
      88,    13,    20,    18,   136,     7,   121,   110,   136,    65,
      83,   136,   136,    62,    71,   106,   111,    11,    16,    76,
      77,    76,    77,    86,    16,    58,    59,   122,   106,    13,
      82,    76,    77,   130,    41,    42,    43,   116,    12,   118,
      86,    86,    12,    86,    15,   130,    12,     7,   136,    10,
      26,    39,    40,   124,   125,   126,   127,   128,   130,   136,
      12,    16,    65,   136,   143,    77,    19,    19,    65,     9,
     136,    86,   120,   130,   129,   130,   112,    40,   126,   128,
      13,   123,    53,   117,     9,   117,    17,    86,   136,    17,
      20,   129,   113,   114,    77,   118,    20,    18,   115,   119,
      18,   117,   143,    77
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,    63,    64,    65,    65,    65,    65,    65,    65,    65,
      65,    65,    65,    65,    66,    67,    68,    68,    69,    69,
      69,    69,    69,    70,    71,    72,    72,    73,    73,    73,
      73,    73,    73,    73,    73,    75,    74,    76,    76,    77,
      77,    79,    78,    80,    80,    82,    81,    83,    83,    85,
      84,    86,    86,    86,    86,    86,    86,    86,    86,    87,
      87,    88,    88,    89,    89,    90,    90,    91,    91,    92,
      93,    93,    95,    94,    97,    96,    99,    98,   100,   100,
     101,   101,   101,   101,   102,   102,   102,   104,   103,   105,
     106,   107,   107,   109,   108,   110,   110,   112,   111,   111,
     113,   113,   114,   115,   116,   116,   116,   116,   117,   117,
     118,   118,   120,   119,   121,   121,   122,   122,   122,   123,
     123,   124,   124,   124,   124,   125,   125,   126,   127,   127,
     128,   129,   130,   130,   130,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   132,   132,   132,   133,   134,   135,
     137,   136,   136,   136,   138,   138,   139,   139,   140,   140,
     141,   141,   142,   142,   143,   144,   144,   144
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     0,     3,     0,     1,     3,
       3,     2,     2,     2,     2,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     6,     1,     1,     1,
       0,     0,     8,     2,     0,     0,     5,     3,     1,     0,
       9,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       2,     3,     1,     4,     2,     5,     3,     5,     3,     1,
       5,     3,     0,     8,     0,     8,     0,    11,     1,     0,
       1,     1,     1,     0,     1,     1,     0,     0,    11,     0,
       0,     2,     0,     0,    10,     2,     0,     0,    11,     3,
       2,     1,     0,     1,     1,     1,     1,     0,     4,     0,
       2,     0,     0,     9,     2,     0,     1,     1,     0,     2,
       0,     1,     1,     1,     1,     3,     1,     5,     3,     1,
       6,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     6,     4,     4,
       0,     5,     2,     0,     3,     1,     3,     1,     1,     0,
       2,     1,     2,     2,     1,     1,     1,     1
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "tok_eof", "error", "\"invalid token\"", "tok_identifier",
  "tok_literal", "tok_doctext", "tok_bool_constant", "tok_int_constant",
  "tok_dub_constant", "\",\"", "\";\"", "\"{\"", "\"}\"", "\"=\"", "\"[\"",
  "\"]\"", "\":\"", "\"(\"", "\")\"", "\"<\"", "\">\"", "\"@\"",
  "tok_include", "tok_namespace", "tok_cpp_include", "tok_hs_include",
  "tok_void", "tok_bool", "tok_byte", "tok_string", "tok_binary",
  "tok_i16", "tok_i32", "tok_i64", "tok_double", "tok_float", "tok_map",
  "tok_list", "tok_set", "tok_stream", "tok_sink", "tok_oneway",
  "tok_idempotent", "tok_readonly", "tok_safe", "tok_transient",
  "tok_stateful", "tok_permanent", "tok_server", "tok_client",
  "tok_typedef", "tok_struct", "tok_exception", "tok_throws",
  "tok_extends", "tok_service", "tok_enum", "tok_const", "tok_required",
  "tok_optional", "tok_union", "tok_interaction", "tok_performs",
  "$accept", "Program", "Identifier", "CaptureDocText", "DestroyDocText",
  "HeaderList", "Header", "Include", "DefinitionAttrs", "DefinitionList",
  "Definition", "Typedef", "$@1", "CommaOrSemicolon",
  "CommaOrSemicolonOptional", "Enum", "$@2", "EnumValueList",
  "EnumValueDef", "$@3", "EnumValue", "Const", "$@4", "ConstValue",
  "ConstList", "ConstListContents", "ConstMap", "ConstMapContents",
  "ConstStruct", "ConstStructType", "ConstStructContents", "Struct", "$@5",
  "Union", "$@6", "Exception", "$@7", "ErrorSafety", "ErrorKind",
  "ErrorBlame", "Service", "$@8", "FlagArgs", "UnflagArgs", "Extends",
  "Interaction", "$@9", "FunctionList", "Function", "$@10", "ParamList",
  "EmptyParamList", "Param", "FunctionQualifier", "MaybeThrows",
  "FieldList", "Field", "$@11", "FieldIdentifier", "FieldQualifier",
  "FieldValue", "FunctionType", "ResponseAndStreamReturnType",
  "StreamReturnType", "ResponseAndSinkReturnType", "SinkReturnType",
  "SinkFieldType", "FieldType", "BaseType", "ContainerType", "MapType",
  "SetType", "ListType", "TypeAnnotations", "$@12", "TypeAnnotationList",
  "TypeAnnotation", "StructuredAnnotations",
  "NonEmptyStructuredAnnotationList", "StructuredAnnotation",
  "FunctionAnnotations", "IntOrLiteral", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   300,   300,   313,   318,   322,   326,   330,   334,   338,
     342,   346,   350,   354,   361,   372,   381,   386,   391,   395,
     402,   409,   416,   423,   443,   455,   460,   465,   470,   475,
     480,   485,   490,   495,   500,   508,   507,   522,   524,   528,
     533,   539,   538,   554,   561,   568,   567,   582,   600,   609,
     608,   630,   636,   649,   655,   660,   690,   695,   700,   707,
     712,   720,   726,   735,   741,   749,   755,   764,   770,   779,
     786,   792,   802,   801,   817,   816,   833,   832,   884,   890,
     895,   901,   907,   913,   918,   924,   930,   937,   936,   952,
     957,   962,   979,   985,   984,  1015,  1022,  1029,  1028,  1048,
    1065,  1077,  1083,  1089,  1096,  1100,  1105,  1111,  1116,  1121,
    1127,  1134,  1141,  1140,  1200,  1205,  1210,  1221,  1233,  1238,
    1248,  1253,  1258,  1263,  1268,  1275,  1281,  1288,  1297,  1303,
    1310,  1320,  1326,  1331,  1336,  1343,  1348,  1353,  1358,  1363,
    1368,  1373,  1378,  1383,  1390,  1395,  1400,  1407,  1414,  1421,
    1429,  1428,  1437,  1443,  1449,  1456,  1466,  1471,  1478,  1484,
    1490,  1496,  1504,  1509,  1519,  1548,  1554,  1562
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 97 "parse/thrifty.yy"
} } } } // apache::thrift::compiler::yy
#line 3886 "/builddir/build/BUILD/fbthrift-2021.08.02.00/redhat-linux-build/thrift/compiler/thrifty.cc"

#line 1570 "parse/thrifty.yy"


/**
 * Method that will be called by the generated parser upon errors.
 */
void apache::thrift::compiler::yy::parser::error(const location_type&, std::string const& message) {
  /*
   * TODO(urielrivas): Pass the location as argument to yyerror.
   */
  driver.yyerror(message);
}
